// Vertex shader for the lens flare effect
#version 430 core

uniform vec2 v[4];

out vec2 texCoord;

void main(void)
{
	//// quad spanning the whole viewport
 //   const vec4 vertex[] = vec4[] ( vec4(-1.0, -1.0, 0.5, 1.0),
 //                                  vec4( 1.0, -1.0, 0.5, 1.0),
 //                                  vec4(-1.0,  1.0, 0.5, 1.0),
 //                                  vec4( 1.0,  1.0, 0.5, 1.0) );

	vec4 vertex[] = vec4[] (
		vec4(v[0], 0.5, 1.0),
		vec4(v[1], 0.5, 1.0),
		vec4(v[2], 0.5, 1.0),
		vec4(v[3], 0.5, 1.0)
	);

	const vec2 texCoords[] = vec2[](	vec2(0.0, 0.0),
										vec2(1.0, 0.0),
										vec2(0.0, 1.0),
										vec2(1.0, 1.0));
	texCoord = texCoords[gl_VertexID];
    gl_Position = vertex[gl_VertexID];
}